# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from project.forms.fields.radio import RadioField
from project.forms.fields.extras.fqdn import FQDNField
from project.forms.fields.extras.enable import EnableField


class SrcField(FQDNField):
    pass


class SrcPasswdField(forms.CharField):
    widget = forms.widgets.PasswordInput
    default_validators = []
    default_error_messages = {
        'required': _(u'Migration: This field is required. Please set the password of source to a non-empty.'),
        # 'invalid': _(u'Enter a valid value.'),
        #  'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
        # 'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }

    def __init__(self, attrs={}, *args, **kwargs):
        if "widget" not in kwargs:
            kwargs["widget"] = self.widget
        if isinstance(kwargs["widget"], type):
            kwargs["widget"] = kwargs["widget"](attrs=attrs, render_value=True)
        super(SrcPasswdField, self).__init__(*args, **kwargs)

    def clean(self, value):
        #from django.core.exceptions import ValidationError
        #import re
        #if not re.match(r"^[a-zA-Z0-9\_\-\.]{,256}$", value):
        #    raise ValidationError(
        #        self.error_messages["invalid"],
        #        code="invalid")
        return super(SrcPasswdField, self).clean(value)


class BoolField(EnableField):
    pass


#class ScheduleField(RadioField):
#
#    # widget = forms.widgets.RadioSelect
#    # default_error_message = {
#    #     'required': _(u'This field is required.'),
#    #     'invalid': _(u'Enter a valid value.'),
#    #     'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
#    # }
#
#    def __init__(self, *args, **kwargs):
#        kwargs["choices"] = (
#            ("Schedule", _(u"Migration: Schedule Execution")),
#            ("Immediate", _(u"Migration: Immediate Execution")))
#        super(ScheduleField, self).__init__(*args, **kwargs)


class ScheduleField(EnableField):
    pass


class DateField(forms.DateField):

    def __init__(self, attrs=None, *args, **kwargs):
        if "input_formats" not in kwargs:
            kwargs["input_formats"] = ['%Y/%m/%d']
        if "widget" not in kwargs:
            kwargs["widget"] = self.widget(
                attrs=attrs,
                format=kwargs["input_formats"][0])
        super(DateField, self).__init__(*args, **kwargs)


class TimeField(forms.TimeField):

    def __init__(self, *args, **kwargs):
        if "input_formats" not in kwargs:
            kwargs["input_formats"] = ['%H:%M']
        super(TimeField, self).__init__(*args, **kwargs)


class ForceFullField(EnableField):
    pass
